/*******************************************************


This program performs image registration.

last modified : Apr 7 2003

*******************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <matrixSHEN.h>
//#include <unistd.h>

extern int optopt;
extern int optind;
extern char *optarg;
extern int opterr;

void showUsage(char *filename)
{
  printf("this program change x,y.\n");
  printf("\n%s inputdeformationfield outputdeformationfield -d X,Y,Z\n", filename);
  printf("\n");
}

main(int argc, char *argv[])
{
  char inputdeformationfield[80], outputdeformationfield[80];

  Deformation_Field *idf, *odf;  

  float original_distance, threshold;
  
  int x, y, z, c, XX, YY, ZZ, k, xx, yy, zz, sw;
  int do_smooth;

  float ok, okok, maxv;

  FPoint FP, zero;
  Points *hood;

  int width = 10;

  sw = 0;

  if (argc<4)
    {
      showUsage(argv[0]);
      exit(1);
    }
  else
    {
      strcpy(inputdeformationfield, argv[1]); 
      strcpy(outputdeformationfield, argv[2]);

      c=getopt(argc-2,argv+2,"d:");
      while(c!= -1)
	{
	  switch(c)
	    {
	    case 'd':
	      sscanf(optarg, "%d,%d,%d", &XX, &YY, &ZZ);
	      break;
	    default:
	      printf("option error\n");
	      break;
	    }
	  c=getopt(argc-2,argv+2,"d:");
	}
    }

  printf("begin program\n");

  idf = new_deformationfield(XX,YY,ZZ);

  read_deformationfield_with_switch(idf, inputdeformationfield, 0);
  write_deformationfield_with_switch(idf, outputdeformationfield, 1);

  free_deformationfield(idf);
}

